clf
close all 
%%% constants %%%
g = 981;         % acceleration of gravity [cm*s^(-2)]
R = 2.5/2;      % tank radius [cm]
r = 0.2/2;      % outlet radius [cm]
A = R^2*pi  % tank area [cm^2]
a = r^2*pi  % outlet area [cm^2]


%%% alpha, beta%%%
dy = 1; %from empty to full tank [1]
h = 17; % [cm]
Vol = A*h; % [cm^3]

% filling upper tank (plugged) at um takes time t 
% final version
u = 1:10; % control signal [V]
t = [65 30 22 13 9 8.3 6.5 5.8 5 4.5]; % ellapsed time [s]

figure(1)
q = Vol./t;
plot(u,q,'*-')
title('control signal - flow')
xlabel('u [V]')
ylabel('q [m^3s^{-1}]')
grid on

figure(2)
k = q./u;
plot(u,k,'*-')
hold on
k = mean(k)
plot(u,ones(size(u))*k,'r-')
title('pump constant')
xlabel('u [V]')
ylabel('ki [m^3s^{-1}V^{-2}]')
grid on

kc = 10/17 % measurement constant [V cm^{-1}]


h0 = 10; % [h10;h20] [cm]

gamma = 0.3;

u0 = a*sqrt(2*g*h0)/k


P = k*[gamma 1-gamma; 1-gamma gamma];
Q = a*sqrt(2*g*h0)*[1;1];
u0 = inv(P)*Q  %P\Q % [V]

h0 = 1/(2*g)*((1-gamma)*k*u0/a).^2 % [h30;h40] [cm]